# frozen_string_literal: true

require_relative 'phonetic_encoder/version'
require_relative 'phonetic_encoder/overloads'
require_relative 'phonetic_encoder/dicts/nato'
require_relative 'phonetic_encoder/dicts/sounds'

#
# Docs to come
#
module PhoneticEncoder
    #
    # To go here
    #
    class Encoder
        $dict = {}

        def self.setup
            $dict['nato'] = NATO
            $dict['sounds'] = SOUNDS
        end

        def self.custom(name, dict)
            $dict[name] = dict
        end

        def self.letter_from_dictionary(letter, dict)
            dict.key?(letter) ? dict[letter].downcase : letter
        end

        def self.encode(text, dict_name = 'nato')
            setup

            dict_name = 'nato' if dict_name.empty?

            return text unless $dict.key?(dict_name)

            result = ''

            text.downcase.split('').each do |letter|
                result += format('%<word>s ', word: letter_from_dictionary(letter, $dict[dict_name]))
            end
            result.rstrip
        end
    end
end
